// UTF-8 ☀☁☂☃
package dialog;
import bluntirc.*;
import irc.*;
import base.*;
import gui.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.beans.PropertyChangeListener;
import java.io.File;
// SwingPropertyChangeSupport
/*
import java.util.*;
*/

public abstract class DialogEditItem_ComboBox extends DialogEditItem{
	abstract public String getCaption();
	abstract public String getPropertyKey();
	abstract public String[] getCaptionList();
	abstract public int getFirstSelected(Object prop_value);
	abstract public Object getListValue(int index);

	public String getDefaultValue(){ return "";}
	public boolean isEditable(){return true;}

	public void applyValue(ConnTreeNode node ,Component c){
		int index =((JComboBox)c).getSelectedIndex();
		node.property.set(getPropertyKey()
			,( index>=0?getListValue(index)
			: ((JTextField)((JComboBox)c).getEditor().getEditorComponent()).getText()
			)
		);
	}

	public Component createControl(ConnTreeNode node){
		JComboBox c = new JComboBox(getCaptionList());
		c.setSelectedIndex(getFirstSelected(node.property.setDefaultString(getPropertyKey(),getDefaultValue())));
		if(isEditable()){
			c.setEditable(true);
			((JTextField)((JComboBox)c).getEditor().getEditorComponent()).setText(node.property.setDefaultString(getPropertyKey(),getDefaultValue()));
		}else{
			c.setEditable(false);
		}
		return c;
	}
	public void layout(Component item,GridBagLayout gbl,GridBagConstraints c,Container panel,Object listener  ){
		((JComponent)item).setFont(textFont);
		((JComboBox)item).addItemListener( (ItemListener)listener );

		JTextArea l = new JTextArea( getCaption() );
		l.setFont(textFont);
		l.setEditable(false);
		l.setForeground(SystemColor.controlText);
		l.setBackground(SystemColor.control);

		JTextArea jta = new JTextArea(getDesc());
		jta.setFont(textFont);
		jta.setEditable(false);
		jta.setForeground(SystemColor.controlText);
		jta.setBackground(SystemColor.control);

		c.weightx = 0.0;c.weighty = 0.0;
		c.fill = GridBagConstraints.NONE;
		c.gridwidth = 1;

		c.anchor = GridBagConstraints.EAST;
		gbl.setConstraints(l, c); panel.add(l);
		c.anchor = GridBagConstraints.WEST ;

		c.fill =  GridBagConstraints.HORIZONTAL;
		c.gridwidth = 2;
		gbl.setConstraints(item, c); panel.add(item);
		c.gridwidth = 1;
		c.fill =  GridBagConstraints.NONE;

		c.gridwidth = GridBagConstraints.REMAINDER; //end row
		gbl.setConstraints(jta, c); panel.add(jta);
	}
}
